// oscillosope prog for dsk 5X
// Ian Munro i.munro@herts.ac.uk
//======= INCLUDES ===============
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <time.h>
#include <dos.h>
#include <bios.h>
#include <graphics.h>
#include <conio.h>
#include "dskdef.h"
//======= DEFINES ================
# define  MAXSCREENLEN 700  // obsolete ?
# define  period 0.2        // time period at 5khz sample rate

//======= EXTERNS ================

extern struct parameter {
		unsigned int  pgm_cnt;
		unsigned int  entrypoint;
		unsigned int  inverse;
		unsigned int  com;
		unsigned long speed;
	       } prm;   // serial parameters

extern const char* programme; // guff should be deleted!
extern const char* pgmdate;   // "      "
extern const char* version;   // "      "
extern const char* copyright; // "      "
extern FILE  *stream;         // file for .dsk
extern unsigned int pcom;     // comport number

// dsk control functions
extern void initializemonitor(void);
extern double LoadDsk(void);
extern void ExePgm(void);
extern void InitPort(void);
extern void WaitFor(unsigned int what);
extern char Bcrcv(int port_no);


//====== Locals =================
void checkkey(void);  // processes any key presses

char sa_kernel_out[]={"osc.dsk"};  // .dsk file name
int  restart = 0; // restart - now obsolete ?
clock_t duration; // time to download dsk file

char  info[300];   // ?
char  title[200];  // ?

int maxsample = 500; // max number of samples that we ever take
int threshold = 1;   // trigger threshold
int sample_rate = 50; // initial sample rate 50 samples per display.
int sample;   // obsolete ??
int rstart =no; // obsolete ??
int srate,osrate;  //sample rate and old sample rate
int first;         // first time through program - obsolete ??
int start,ostart;  // starting sample - old starting sample

char buffer[501];  // current sample buffer
char buffer2[501]; // old sample buffer
char bit_rate    = 0xFF; // bit rate mask
double rate,orate;  //sample rate coeff old sample coeff
float time_base = 1.0; // time base ms per div


void setup_vals(void) // sets up the oscilloscope display
{
  setwritemode(0);                      // turn off XOR write
  setviewport(0,300,200,309,1);
  clearviewport();
  setviewport(100,0,620,30,1);
  setcolor(14);
  settextstyle(0,0,2);
  outtextxy(80,10,"DSK OSCILLOSCOPE");
  setviewport(0,30,620,330,1);
  setcolor(11);
  settextstyle(0,0,0);
  outtextxy(10,7,  "       5V ");
  outtextxy(10,33, "       4V ");
  outtextxy(10,59, "       3V ");
  outtextxy(10,72, "  A       ");
  outtextxy(10,85, "  M    2V ");
  outtextxy(10,98, "  P       ");
  outtextxy(10,111,"  L    1V ");
  outtextxy(10,124,"  I       ");
  outtextxy(10,137,"  T    0V ");
  outtextxy(10,150,"  U       ");
  outtextxy(10,163,"  D   -1V ");
  outtextxy(10,176,"  E       ");
  outtextxy(10,189,"      -2V ");
  outtextxy(10,215,"      -3V ");
  outtextxy(10,241,"      -4V ");
  outtextxy(10,267,"      -5V ");
//  outtextxy(400,290,"Sampling at 5Khz");
  outtextxy(100,290,"(Q)uit to DOS   ");
}

void start_display(void) // inits the display driver
{
  int gdriver = EGA, gmode = EGAHI, errorcode, Y, X;
  initgraph(&gdriver, &gmode, "");        // if possible open EGA mode
  errorcode = graphresult();
  if (errorcode != grOk)
  {
     printf("Graphics error: %s\n", grapherrormsg(errorcode));
     printf("Press any key to halt:");
     getch();
     exit(1);
  }
  clearviewport();                        //
  setup_vals();                           // dispaly the setup
  setviewport(100,40,600,300,1);          // Set window to show display
  setcolor(2);                            // reticle is green
  for(Y=0;Y<=260;Y+=26) line(0,Y,500,Y);  // draw reticle
  for(X=0;X<=500;X+=50) line(X,0,X,260);  //
  setwritemode(1);                        // display lines are XOR drawn
  setcolor(15);                           // light gray
}




int main(int argc, char *argv[])
{
  char displaybuff[50]; // small text buffer
  int TA; // obsolete ????
  int two_block_length,block_length,address; // obsolute ?????
  int k,f,c, number_overrun,BRD; // obsolute ????
  float SCF, FDAC;  // obsolete ???

  if(argc > 3){
     printf("Please enter the command as 'oscope -cx'\n");
     printf("  where x is the comport that DSK connect to.\n");
     printf("  (The default value is 1 for comport 1)\n");
     exit(0);
  }
  else{
     strlwr(argv[1]);
     if(argv[1]){
	if(strstr(argv[1],"-c"))
	   prm.com = argv[1][2]-'1';
	else{
	   printf("Please enter the command as 'oscope -cx'\n");
	   printf("  where x is the comport that DSK connect to.\n");
	   printf("  (The default is 1 for comport 1)\n");
	   exit(0);
	    }
	       }
       }
  clrscr();
  sprintf(title,"\n%s - Version %s / %s "
		"\n%s\n",programme,version,pgmdate,copyright);
  printf(title);
  prm.entrypoint=prm.pgm_cnt=0x0a00;   // standard entry point
  prm.inverse   =yes;              // for standard boards like DSK
re_start:
  maxsample = 500;
  threshold = 1;
  rstart =no;
  bit_rate = 0xFF;
  sample_rate = 50;
  prm.speed=57600;                 // default !
  initializemonitor();   // Establish communication at 57600 baud using old kernel

//------------------------------------------------------------------
// Load Spectrum Analyzer Kernel
//------------------------------------------------------------------

  printf("\nDownloading oscope code...\n");
  stream=fopen(sa_kernel_out,"rb");
  duration = LoadDsk();
  if (duration == 0) exit(0);
  ExePgm();

//------------------------------------------------------------------
// Reinitialize PC serial port to 115200 baud
//------------------------------------------------------------------
  prm.speed=115200l;
  delay(50);
  InitPort();
  start_display();
  delay(50);
  first = no;
  start = 0;
  ostart =0;

  // draw one set of 'duff' samples in anticipation of them being
  // overwritten.
  setcolor(LIGHTRED);
  for(f=start;f<=(start+sample_rate);f++)
  {
    line((f-start)*(rate),130,(f-start)*rate,130-buffer[f]);
  }
  setcolor(WHITE);
  for(f=start;f<=(start+49);f++)
  {
    line((f-start)*10,130-buffer[f],((f+1)-start)*10,130-buffer[f+1]);
  }

  // main loop
  for (;;)
  {
    while (kbhit()) checkkey();
    if (rstart == yes)
    {
      rstart = no;
      goto re_start;
    }
// Turn off interrupt and reading the data from DSP
// Take 500 samples  and then scan for the trigger point
    asm cli;
    for(f=0;f<=maxsample;f++)
      buffer[f] = (Bcrcv(pcom))*1.35;// twiddle factor to get correct gain
    asm sti;

    first = no;
    ostart = start;
    start = 0;
    for (f=0;f<=maxsample;f++)
    {
      if ( buffer[f] < threshold) first = yes;
      if ((buffer[f] >= threshold)&&(first==yes))
      {
	first = no;
	start = f;
	break;
      }
    }
    if (f>(maxsample-srate)) start =0;
    for (f=0;f<maxsample;f++)
    {
      buffer[f] = (buffer[f]&bit_rate);
      if (bit_rate ==  -128)
	buffer[f] = buffer[f] +64;
      if (bit_rate ==  -64)
	buffer[f] = buffer[f] +32;
      if (bit_rate ==  -32)
	buffer[f] = buffer[f] +16;
      if (bit_rate ==  -16)
	buffer[f] = buffer[f] +8;
      if (bit_rate ==  -8)
	buffer[f] = buffer[f] +4;
      if (bit_rate ==  -4)
	buffer[f] = buffer[f] +2;
      if (bit_rate ==  -2)
	buffer[f] = buffer[f] +1;
    }



    srate = (10.0 * time_base)/period;
    rate = (double)maxsample/srate;

    if (osrate==srate)
    {
      setcolor(LIGHTRED);
      for(f=0;f<=srate;f++)
      {
	setcolor(LIGHTRED);
	line(f*rate,130,(f*rate),130-buffer2[ostart+f]);
	line(f*rate,130,(f*rate),130-buffer[start+f]);
	if (f<=srate-1)
	{
	  setcolor(WHITE);
	  line(f*rate,130-buffer2[ostart+f],(f+1)*rate,130-buffer2[ostart+f+1]);
	  line(f*rate,130-buffer[start+f],(f+1)*rate,130-buffer[start+f+1]);
	}
      }
    }
    else
    {
      setcolor(LIGHTRED);
      for(f=ostart;f<=(ostart+osrate);f++)
      {
	line((f-ostart)*orate,130,(f-ostart)*orate,130-(buffer2[f]));
      }
      setcolor(WHITE);
      for(f=ostart;f<=(ostart+osrate-1);f++)
      {
	line((f-ostart)*orate,130-buffer2[f],((f+1)-ostart)*orate,
			   130-buffer2[f+1]);
      }
      setcolor(LIGHTRED);
      for(f=start;f<=(start+srate);f++)
      {
	line((f-start)*rate,130,(f-start)*rate,130-(buffer[f]));
      }
      setcolor(WHITE);
      for(f=start;f<=(start+srate-1);f++)
      {
	line((f-start)*rate,130-buffer[f],((f+1)-start)*rate,130-buffer[f+1]);
      }
    }

    osrate = srate;
    orate  = rate;
    ostart = start;
    for (f=0;f <maxsample;f++)
      buffer2[f] = buffer[f];
    sprintf(displaybuff,"Timebase %.1f ms/div",time_base);
    setviewport(400,305,600,315,1); // setup port for text;
    clearviewport();
    setcolor(11);
    outtextxy(0,0,displaybuff);
    setviewport(100,40,600,300,1);          // Set window to show display
  }
}

void checkkey(void)
{
  int key, f;
  key = (bioskey(0)) >> 8;
  switch(key)
  {
// do quantizing guff
    case 0x02: bit_rate = 0x80;          // key 1;
      break;
    case 0x03: bit_rate = 0xC0;          // key 2;
      break;
    case 0x04: bit_rate = 0xE0;          // key 3;
      break;
    case 0x05: bit_rate = 0xF0;          // key 4;
      break;
    case 0x06: bit_rate = 0xF8;          // key 5;
      break;
    case 0x07: bit_rate = 0xFC;          // key 6;
      break;
    case 0x08: bit_rate = 0xFE;          // key 7;
      break;
    case 0x09: bit_rate = 0xFF;          // key 8;
      break;
// time base keys
    case 0x4D : time_base -= .10;       // <-
      if (time_base < .10) time_base = .10;
      break;
    case 0x4B: time_base += .10;
      if (time_base > 5.0) time_base = 5.0;
      break;
    case 0x10: closegraph();            // (Q)uit to DOS
      exit(0);          break;
    default :                    break;
  }
}
