//Original code by Texas Instuments
//re-hashed I.Munro should be ok with EGA


//!!!!!!!!!!  Important !!!!!!!!!!!!
//Don't forget to switch on graphics libs in LINKER if no project
//file is used !!!!!!!
//===============================================================
#include <stdio.h>
#include <time.h>
#include <graphics.h>
#include <bios.h>
#include <stdlib.h>
#include <stdarg.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include "dskdef.h"
//#include "dsk_func.h"
extern struct parameter {
	   unsigned int  pgm_cnt;
	   unsigned int  entrypoint;
	   unsigned int  inverse;
	   unsigned int  com; // comport
	   unsigned long speed; // Baudrate
	 } prm;
extern const char* programme;
extern const char* pgmdate;
extern const char* version;
extern const char* copyright;
extern FILE  *stream;        // global for this file

// global variables
extern unsigned int       pcom;

# define  MAXSCREENLEN 700
char sa_kernel_out[]={"spec50.dsk"};

// global variables
char       info[300];
char       title[200];

char buf_0[512];                      // Keep past data history for
char buf_1[512];                      // time averaging of signals
char buf_2[512];
char buf_3[512];
char buf_4[512];
char buf_5[512];
char buf_6[512];
char buf_7[512];
char buf_8[512];

char buf_pk_t[512];
int  buf_y_pk[512];

int avg_on = 0;
int restart = 0;
clock_t duration;

extern void initializemonitor(void);


//=================Setup_vals =========================================
void setup_vals(void)
{
  setwritemode(0);                      // turn off XOR write
  setviewport(0,300,200,309,1);        // clear window
  clearviewport();                      //
  setviewport(100,0,620,30,1);          // Write the title in yellow
  setcolor(14);
  settextstyle(0,0,2);
  outtextxy(70,10,"DSK SPECTRUM ANALYZER");
  setviewport(0,30,620,330,1);          // Write to window in bright blue
  setcolor(11);                         //
  settextstyle(0,0,0);
  outtextxy(10,33, "     +10dB");
  outtextxy(10,59, "      +0dB");
  outtextxy(10,72, "  M       ");
  outtextxy(10,85, "  A  -10dB");
  outtextxy(10,98, "  G       ");
  outtextxy(10,111,"  N  -20dB");
  outtextxy(10,124,"  I       ");
  outtextxy(10,137,"  T  -30dB");
  outtextxy(10,150,"  U       ");
  outtextxy(10,163,"  D  -40dB");
  outtextxy(10,176,"  E       ");
  outtextxy(10,189,"     -50dB");
  outtextxy(10,215,"     -60dB");
  outtextxy(10,241,"     -70dB");
  outtextxy(450,270,"SPEC50.EXE    ");   // Name of program
  outtextxy(450,280,"FFT: 256 Radix-2");   //
  outtextxy(450,290,"10 dB/div:      ");   //
  outtextxy(96,250,"DC");
  outtextxy(185,250," 950");
  outtextxy(285,250,"1900");
  outtextxy(385,250,"2850");
  outtextxy(485,250,"3800");
  outtextxy(585,250,"4750");
  outtextxy(224,260,"         Frequency (Hz)         ");
  outtextxy(100,290,"(Q)uit to DOS   ");   //
  outtextxy(100,280,"(R)eboot DSK    ");   //
  switch(avg_on)
  {
    case  1: outtextxy(100,270,"(A)verage 2");break; //
    case  2: outtextxy(100,270,"(A)verage 4");break; //
    case  3: outtextxy(100,270,"(A)verage 8");break; //
    default: outtextxy(100,270,"(A)verage 1");break; //
  }
}
//end (Setup_vals)

//=================Check_key ================================================

void check_key(void)
{
  int key;
  key = (bioskey(0)) >> 8;
  switch(key)                           // Key traps for various routines
  {
    case 0x1E: avg_on += 1;             // (A)veraging select
	       if(avg_on >3)
		 avg_on = 0;     break;
    case 0x13: restart = 1;             // (R)eboot code
	       break;
    case 0x10: closegraph();            // (Q)uit to DOS
	       exit(0);          break;
    default :                    break;
  }
  setup_vals();                         // redraw the setup values
  setviewport(100,40,600,274,1);        // Set window to show display
  setwritemode(1);                      // display lines are XOR drawn
  setcolor(15);                         // light gray
}
//end (check_key)


//================= screen ==================================================
int screen(unsigned int x,unsigned int y,char *fmt,...)
{
 static char buffer[MAXSCREENLEN];
 int cnt;
 va_list argptr;
 va_start(argptr,fmt);
 cnt=vsprintf(buffer,fmt,argptr);
 va_end(argptr);
 gotoxy(x,y);
 cprintf(buffer);
 clreol();
 return cnt;
}
//end (screen)

//=================init_graphics=============================================
void init_graphics(void)
{
  int gdriver = EGA, gmode = EGAHI, errorcode, Y, X;
//  registerbgidriver(EGAVGA_driver);     // Use with BCC for no EGAVGA.BGI
  initgraph(&gdriver, &gmode, "");        // if possible open EGA mode
  errorcode = graphresult();
  if (errorcode != grOk)
  {
     printf("Graphics error: %s\n", grapherrormsg(errorcode));
     printf("Press any key to halt:");
     getch();
     exit(1);
  }
  clearviewport();                        //
  setup_vals();                           // dispaly the setup
  setviewport(100,40,600,274,1);          // Set window to show display
  setcolor(2);                            // reticle is green
  for(Y=0;Y<=234;Y+=26) line(0,Y,500,Y);  // draw reticle
  for(X=0;X<=500;X+=50) line(X,0,X,234);  //
  setwritemode(1);                        // display lines are XOR drawn
  setcolor(15);                           // light gray
}
//end (init_graphics)


//--------------------------------------------------------------------
// Main program
//--------------------------------------------------------------------
int main(int argc, char *argv[])
{
  char *ptr1, *ptr2, *ptr3, *ptr4;
  char *ptr5, *ptr6, *ptr7, *ptr8, *ptr0;
  char *tmp0, *tmp1, *tmp2, *tmp3, *tmp4;
  char *tmp5, *tmp6, *tmp7, *tmp8, *pk_t;
  int  x, y, old_y, xx, *y_pk;
  int TA;
  int two_block_length,block_length,address;
  int k,c, number_overrun,BRD;
  float SCF, FDAC;

  if(argc > 3){
     printf("Please enter the command as 'SPEC50 -cx'\n");
     printf("  where x is the comport that DSK connect to.\n");
     printf("  (The default value is 1 for comport 1)\n");
     exit(0);
  }
  else{
     strlwr(argv[1]);
     if(argv[1]){
	if(strstr(argv[1],"-c"))
	   prm.com = argv[1][2]-'1';
	else{
	   printf("Please enter the command as 'FFT -cx'\n");
	   printf("  where x is the comport that DSK connect to.\n");
	   printf("  (The default is 1 for comport 1)\n");
	   exit(0);
	}
     }
  }
  clrscr();
  sprintf(title,"\n%s - Version %s / %s "
		"\n%s\n",programme,version,pgmdate,copyright);
  printf(title);
  prm.entrypoint=prm.pgm_cnt=0x0a00;   // standard entry point
  prm.inverse   =yes;              // for standard boards like DSK
re_start:
  prm.speed=57600;                 // default !
  initializemonitor();   // Establish communication at 57600 baud using old kernel

//------------------------------------------------------------------
// Load Spectrum Analyzer Kernel
//------------------------------------------------------------------

  printf("\nDownloading FFT code...\n");
  stream=fopen(sa_kernel_out,"rb");
  duration = LoadDsk();
  ExePgm();

//------------------------------------------------------------------
// Reinitialize PC serial port to 115200 baud
//------------------------------------------------------------------
  prm.speed=115200l;
  InitPort();
  init_graphics();
//------------------------------------------------------------------
// This module test the transfering of data without handshaking
//------------------------------------------------------------------
  two_block_length=128;
  tmp0 = buf_0;
  tmp1 = buf_1; tmp2 = buf_2; tmp3 = buf_3; tmp4 = buf_4;
  tmp5 = buf_5; tmp6 = buf_6; tmp7 = buf_7; tmp8 = buf_8;

  ptr0 = tmp0;
  for(x=0;x<256;x+=2) *ptr0++ = 128;  // init 1st line
  for(x=0;x<512;x++){
      buf_y_pk[x] = 0;
      buf_pk_t[x] = NULL;
  }
  for(         ;        ;     ) {
      ptr0 = tmp0;                            // Set buffer data pointers
      ptr1 = tmp1; ptr2 = tmp2; ptr3 = tmp3; ptr4 = tmp4;
      ptr5 = tmp5; ptr6 = tmp6; ptr7 = tmp7; ptr8 = tmp8;
      y_pk = buf_y_pk;
      pk_t = buf_pk_t;

      for(x=0;x<512;x+=4) {
	  old_y = 128 - *ptr0;
	  switch(avg_on) {
	    case  1: *ptr0 = (*ptr1+*ptr2) >> 1;   // avg of 2
		     break;
	    case  2: *ptr0 = (*ptr1+*ptr2+*ptr3+*ptr4) >> 2; // avg of 4
		     break;
	    case  3: *ptr0 = (*ptr1+*ptr2+*ptr3+*ptr4+      // avg of 8
			      *ptr5+*ptr6+*ptr7+*ptr8) >> 3;
		     break;
	    default: *ptr0 = *ptr1;
		     break;                             // avg of 1
	  }
	  y = 128 - *ptr0;
	  *pk_t += 1;
	  if((*pk_t > 8) || (y < *y_pk)) {
	     setcolor(LIGHTRED);
	     line(x+3, *y_pk  ,x+7, *y_pk  );  // undraw old peak
	     if(y < *y_pk) {
		*y_pk = y;
		*pk_t = 0;
	     }
	     else
		*y_pk += 6;
	     line(x+3, *y_pk  ,x+7, *y_pk  );  // draw new peak
	     setcolor(WHITE);
	  }
	  y_pk++;
	  pk_t++;
//----------------------------
	  if(y > old_y){
	     old_y++;
	     line(x+5,old_y,x+5,y);
	  }
	  if(y < old_y){
	     y++;
	     line(x+5,old_y,x+5,y);
	  }
	  ptr0++;
	  ptr1++; ptr2++; ptr3++; ptr4++;               // next data
	  ptr5++; ptr6++; ptr7++; ptr8++;
      }
      if(kbhit()) check_key();
      if(restart){
	 avg_on=restart=0;
	 closegraph();
	 goto re_start;
      }
      ptr1 = tmp8;                    // Rotate the buffer pointers
      tmp8 = tmp7; tmp7 = tmp6; tmp6 = tmp5; tmp5 = tmp4;
      tmp4 = tmp3; tmp3 = tmp2; tmp2 = tmp1; tmp1 = ptr1;

      for(k = 10000; k > 0; k--){
	  WaitFor(XMT_BUF_EMPTY);    // Send a pulse to DSP then wait for
	  outportb(pcom,NULL);       // starting pulse 0x80
	  delay(1);
	  c = inportb(pcom);
	  if( c == 0x80 ){              // reveive starting pulse 0x80 send
	      WaitFor(XMT_BUF_EMPTY);   // 0x1b to DSP indicate "ready to
	      outportb(pcom,0x1B);      // receive 128 data with interrupt
	      break;                    // turn-off
	  }
      }
      if( k == 0 ){
	  printf("Fail to get start pulse\n");
	  exit(0);
      }

// Turn off interrupt and reading the data from DSP
      asm cli;
      WaitFor(XMT_BUF_EMPTY);
      outport(pcom,NULL);
      for(k=0;k<two_block_length;k++)
	  *ptr1++=Bcrcv(pcom);
      asm sti;
  }

}
